diff --git a/src/backend/catalog/storage.c b/src/backend/catalog/storage.c
index 3cc886f7fe..0a38a32734 100644
--- a/src/backend/catalog/storage.c
+++ b/src/backend/catalog/storage.c
@@ -290,6 +290,13 @@ RelationTruncate(Relation rel, BlockNumber nblocks)
 			XLogFlush(lsn);
 	}
 
+	{
+		struct stat stat_buf;
+
+		if (stat("/tmp/truncate_flag", &stat_buf) == 0)
+			elog(ERROR, "/tmp/truncate_flag is present");
+	}
+
 	/* Do the real work */
 	smgrtruncate(rel->rd_smgr, MAIN_FORKNUM, nblocks);
 }
